
import java.lang.*;
import java.awt.*;
import java.applet.*;
// import java.awt.event.*;

import Node;

public class Link extends Object {
  /* From where to where */
  Node m_Node1;
  Node m_Node2;

  /* the bandwidth of the link */
  int m_nBandwidth;

  /* the dimmensions of the retacngle */
  public final static int LINK_XDIM = 8;
  public final static int LINK_YDIM = 8;


  public Link( Node node1, Node node2, int bandwidth ) {
    m_Node1 = node1; m_Node2 = node2;
    m_nBandwidth = bandwidth;
  }
  
  /* member getting */
  public int getBandwidth( ) { return m_nBandwidth ; }
  public Node getNode1() { return m_Node1; }
  public Node getNode2() { return m_Node2; }

  /* Determine if a point is inside the link's rect .. */
  public boolean isInside( int X, int Y ) {
    return ( X > ( m_Node1.getX() + m_Node2.getX() ) / 2 - LINK_XDIM / 2 &&
	     X < ( m_Node1.getX() + m_Node2.getX() ) / 2 + LINK_XDIM / 2 &&
	     Y > ( m_Node1.getY() + m_Node2.getY() ) / 2 - LINK_YDIM / 2 &&
	     Y < ( m_Node1.getY() + m_Node2.getY() ) / 2 + LINK_YDIM / 2  );
  }

  /* painting */
  public void paintLink( Graphics g ) {
    g.setColor( Color.black );
    g.drawLine( m_Node1.getX(), m_Node1.getY(),
		m_Node2.getX(), m_Node2.getY() );
    g.setColor( Color.blue );
    g.fillRect( ( m_Node1.getX() + m_Node2.getX() ) / 2 - LINK_XDIM / 2, 
		( m_Node1.getY() + m_Node2.getY() ) / 2 - LINK_YDIM / 2, 
		LINK_XDIM, LINK_YDIM );
  }

  /* this returns an info string */
  String getInfoString( ) {
    return new String( "Capacity : " + getBandwidth() );
  }
}
