import java.lang.*;
import java.net.*;
import java.io.*;
import OutFrame;


public class ReaderThread extends Thread {
  /* The frame .. */

  OutFrame m_frame;

  Socket m_socket;
  DataInputStream m_inputStream;


  public ReaderThread( Socket socket, OutFrame f ) {
    m_frame = f;
    m_socket = socket;

  }
  
  /* This does the real receiving job.. */
  public void run(){
    try {
    /* Get also the input stream.. */
    m_inputStream = new DataInputStream
      ( new BufferedInputStream( m_socket.getInputStream()));

    /* receive next n and Throughput */
    for( m_frame.m_nCrtIndex = 0; m_frame.m_nCrtIndex < m_frame.m_nPoints; m_frame.m_nCrtIndex++ ){
     /* read the data */
     m_frame.m_dN[ m_frame.m_nCrtIndex ] = m_inputStream.readDouble();
     m_frame.m_dThroughput[ m_frame.m_nCrtIndex ] = m_inputStream.readDouble();
     
     /* recompute min / max */
     if( m_frame.m_dN[ m_frame.m_nCrtIndex ] > m_frame.m_dMaxN ) 
       m_frame.m_dMaxN = m_frame.m_dN[m_frame.m_nCrtIndex ];

     if( m_frame.m_dN[ m_frame.m_nCrtIndex ] < m_frame.m_dMinN ) 
       m_frame.m_dMinN = m_frame.m_dN[ m_frame.m_nCrtIndex ];

     if( m_frame.m_dThroughput[ m_frame.m_nCrtIndex ] > m_frame.m_dMaxTh ) 
       m_frame.m_dMaxTh = m_frame.m_dThroughput[ m_frame.m_nCrtIndex ];

     if( m_frame.m_dThroughput[ m_frame.m_nCrtIndex ] < m_frame.m_dMinTh ) 
       m_frame.m_dMinTh = m_frame.m_dThroughput[ m_frame.m_nCrtIndex ];
    
     /* Update the curent drawing values */
     if( m_frame.m_bDrawN ) {
	m_frame.m_dMinDraw = m_frame.m_dMinN;
	m_frame.m_dMaxDraw = m_frame.m_dMaxN;
	m_frame.m_dDataDraw = m_frame.m_dN;

	m_frame.m_strNameDraw = new String( "N( t )" );
     }
     else {
  	m_frame.m_dMinDraw = m_frame.m_dMinTh;
	m_frame.m_dMaxDraw = m_frame.m_dMaxTh;
	m_frame.m_dDataDraw = m_frame.m_dThroughput;

	m_frame.m_strNameDraw = new String( "Th( t )" );
     }

     m_frame.repaint();
    }
    
    /* Finish the conversation */

    /* Get the in / out streams */
    DataOutputStream os = new DataOutputStream
      ( m_socket.getOutputStream() );

    /* confirmation */
    os.write(0);
    os.flush();
    
    m_socket.close();
    }
    catch( Exception e ) {
      stop();
    }
  }
  
  
}
